#ifndef gps_h 
#define gps_h

struct gps {
	char sentence[255];	// The raw GPS data
	uint8_t H, M, S;	// Hour, Minute, Second
	uint8_t y, m, d;	// year, month, day
	uint8_t valid;		// Valid if unit has fix
	double lat; 		// Latitude coord
	double lon;			// Longitude coord
	double speed;		// Speed in Km/h
	double course;		// Course if any
	double var;			// Magnetic variance
	double alt;  		// Altitude
	uint8_t satinuse;	// Satellites in use
	uint8_t satinview;	// Satellites in view
	uint8_t fixmode;	// Fix Mode (1 = no fix, 2 = 2D fix, 3 = 3D fix)
	uint8_t fixquality;	// Fix Quality (0 = no fix, 1 = fix, 2 = fix)
	uint8_t hdop;		// Relative accuracy of horizontal position
};


uint8_t gps_poll(struct gps *gps);
double gps_distance( double latitude1, double longitude1, double latitude2, double longitude2 );
double gps_bearing( double latitude1, double longitude1, double latitude2, double longitude2 );


#endif 