#ifndef init_h
#define init_h


// General defines for this project
#define F_MCU 				"atmega1284p"		// just some info


// General SPI settings (SPI)
#define SPI_SS				PB4					// PORTB pin 4
#define SPI_MOSI			PB5					// PORTB pin 5
#define SPI_MISO			PB6					// PORTB pin 6
#define SPI_SCK				PB7					// PORTB pin 7
#define SPI_PORT			PORTB				// PORTB
#define SPI_REG				DDRB				// DDRB
#define SPI_DATA_REG		SPDR				// SPDR
#define SPI_STATUS_REG		SPSR				// SPSR
#define SPI_INT				SPIF				// SPIF

// Power indicator LED (PWR)
#define PWR_LED_PIN			PD6					// PORTD pin 6
#define PWR_LED_REG			DDRD				// Data Direction Register D
#define PWR_LED_PORT		PORTD				// PORT D


// Vibration motor indicator (VIBRATE)
#define VIBRATE_PIN 		PD7					// PORTD pin 7
#define VIBRATE_REG			DDRD				// Data Direction Register D
#define VIBRATE_PORT		PORTD				// PORT D


// Display (DPY)
/*
 * Connect display controller SSD1306 as follows:
 *
 * (driven as a input only display)
 *
 * SSD1306 pin				AVR/system
 *
 * GND	 					GND
 * Vin	 					+5
 * 3v3   					NC
 * CS    					PA0
 * RST 	 					PA1
 * DC/SA0					PA2
 * SS    					PB4=NC
 * CLK   					PB7/SCK
 * DATA  					PB5/MOSI
 *
 */
// Port/pin use in addition to the MCU's SPI for control
#define DPY_CTRL_REG		DDRA				// DDRA
#define DPY_PORT  			PORTA				// PORTA
#define DPY_CS    			PA0					// PA0
#define DPY_RST   			PA1					// PA1
#define DPY_DC    			PA2					// PA2


// UART (UARDX)
// option CFLAGS += -DF_CPU=11059200 in Makefile #define F_CPU 11059200UL
#define UART1_BAUD 			9600				// 9600
#define UART2_BAUD 			9600				// 9600


// SD CARD (SDC)
#define SDC_CTRL_REG		DDRC				// DDRA
#define SDC_PORT  			PORTC				// PORTA
#define SDC_CS    			PC2					// PC2

// Power indicator LED (SDC)
#define SDC_LED_PIN			PD5					// PD5
#define SDC_LED_REG			DDRD				// DDRD
#define SDC_LED_PORT		PORTD				// PORTD

void init_init(void);
void init_spi(void);
void init_uart(void);

#endif
