#ifndef sd_h 
#define sd_h

/* 
SD Card SPI Mode CMD's

CMD0 GO_IDLE_STATE +
CMD1 SEND_OP_CND + NOTICE: DO NOT USE (SEE Fig.6 and 9.2)
CMD9 SEND_CSD +
CMD10 SEND_CID +
CMD12 STOP_TRANSMISSION +
CMD13 SEND_STATUS +
CMD16 SET_BLOCKLEN +
CMD17 READ_SINGLE_BLOCK +
CMD18 READ_MULTIPLE_BLOCK +
CMD24 WRITE_BLOCK +
CMD25 WRITE_MULTIPLE_BLOCK +
CMD27 PROGRAM_CSD +
CMD28 SET_WRITE_PROT - Internal Write Protection is not implemented.
CMD29 CLR_WRITE_PROT - Internal Write Protection is not implemented.
CMD30 SEND_WRITE_PROT - Internal Write Protection is not implemented.
CMD32 ERASE_WR_BLK_START_ADDR +
CMD33 ERASE_WR_BLK_END_ADDR +
CMD38 ERASE +
CMD42 LOCK_UNLOCK - Card Lock/Unlock Function is not implemented.
CMD55 APP_CMD +
CMD56 GEN_CMD - This command is not specified.
CMD58 READ_OCR +
CMD59 CRC_ON_OFF +
ACMD6 SET_BUS_WIDTH +
ACMD13 SD_STATUS +
ACMD22 SEND_NUM_WR_BLOCKS +
ACMD23 SET_WR_BLK_ERASE_COUNT +
ACMD41 SD_APP_OP_COND +
ACMD42 SET_CLR_CARD_DETECT +
ACMD51 SEND_SCR +
ACMD18 SECURE_READ_MULTI_BLOCK +
ACMD25 SECURE_WRITE_MULTI_BLOCK +
ACMD26 SECURE_WRITE_MKB +
ACMD38 SECURE_ERASE +
ACMD43 GET_MKB +
ACMD44 GET_MID +
ACMD45 SET_CER_RN1 +
ACMD46 SET_CER_RN2 +
ACMD47 SET_CER_RES2 +
ACMD48 SET_CER_RES1 +
ACMD49 CHANGE_SECURE_AREA + 

Communication with the SD card is performed by sending commands to it and receiving responses from it. 
A valid SD card command consists of 48 bits 

bit 0		"1"
bit 1-7		CRC -> Only used for CMD8
bit 9-39	Argument
bit 40-45	Command Number
bit 46		"1"
bit 47		"0"


Sources:
http://www.dejazzer.com/ee379/lecture_notes/lec12_sd_card.pdf
http://elm-chan.org/docs/mmc/mmc_e.html


*/


void sd_init(void);

#endif 